/*
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2, or (at your option)
 * any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * Copyright (c) 2001  HASEGAWA Masafumi
 */

#ifndef __EBI_CHAR_H
#define __EBI_CHAR_H

#include "ebi_config.h"
#include "ebi_element.h"
#include "ebi_global.h"

__EBI_BEGIN_NAMESPACE

class Char : public Element
{
 public:
  Char (TC code, FontType fontType);
  virtual ~Char ();

  virtual W getWidth () const;
  virtual W updateSize (Device* device);
  virtual void updateLayout (PNT* pnt, W max);
  virtual void draw (Device* device, W low, W high);
  virtual bool isHit (const PNT& pnt) const;
  virtual void getString (String* str) const;

 private:
  TC m_code;
  FontType m_fontType;
  W m_width;
  W m_height;
  PNT m_pnt;

  void setFont (GID gid, W width);
};

__EBI_END_NAMESPACE

#endif /* __EBI_CHAR_H */
