/*
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2, or (at your option)
 * any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * Copyright (c) 2001  HASEGAWA Masafumi
 */

#ifndef __EBI_CODE_H
#define __EBI_CODE_H

#include "ebi_config.h"
#include "ebi_string.h"

__EBI_BEGIN_NAMESPACE

class Code
{
 public:
  Code ();

  static TC asciiToTron (UB src);
  static TC latin1ToTron (UB src);
  static TC eucJpToTron (UH src);
  static TC eucGbToTron (UH src);
  static void tronToEucJp (const TC * src, std::string * dest);
  static void eucJpToTron (const char *src, String * dest);
  static void tronToLatin1 (const TC * src, std::string * dest);
  static void latin1ToTron (const char *src, String * dest);
  static bool Code::isLatin1 (TC code);

 private:
  static const TC c_asciiTable[];
  static const int c_asciiSize;
  static const TC c_latin1Table[];
  static const int c_latin1Size;
};

__EBI_END_NAMESPACE

#endif /* __EBI_CODE_H */
