/*
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2, or (at your option)
 * any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * Copyright (c) 2001  HASEGAWA Masafumi
 */

#ifndef __EBI_FONTSET_H
#define __EBI_FONTSET_H

#include "ebi_config.h"
#include "ebi_global.h"

__EBI_BEGIN_NAMESPACE

class BitmapFont;

class Fontset
{
 public:
  Fontset (EB_Book * book, EB_Font_Code fontCode);
  virtual ~Fontset ();

  void clear ();
  BitmapFont *getBitmapFont (EB_Subbook_Code subbook, int code, FontType fontType);

 private:
  typedef std::map<int, BitmapFont*> Fonts;

  EB_Book *m_book;
  EB_Font_Code m_fontCode;
  Fonts m_narrowFonts;
  Fonts m_wideFonts;
};

__EBI_END_NAMESPACE

#endif /* __EBI_FONTSET_H */
