/*
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2, or (at your option)
 * any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * Copyright (c) 2001  HASEGAWA Masafumi
 */

#ifndef __EBI_HOOKSET_H
#define __EBI_HOOKSET_H

#include "ebi_config.h"

__EBI_BEGIN_NAMESPACE

class Book;
class PageMaker;

class Hookset
{
 public:
  Hookset ();
  virtual ~Hookset ();

  EB_Hookset *getHookset ();
  void setPageMaker (PageMaker * pageMaker);
  EB_Error_Code hookNewLine (EB_Book* book, void* container, int argc, const unsigned int* argv);
  EB_Error_Code hookBeginNoNewLine (EB_Book* book, void* container, int argc, const unsigned int* argv);
  EB_Error_Code hookEndNoNewLine (EB_Book* book, void* container, int argc, const unsigned int* argv);
  EB_Error_Code hookBeginReference (EB_Book* book, void* container, int argc, const unsigned int* argv);
  EB_Error_Code hookEndReference (EB_Book* book, void* container, int argc, const unsigned int* argv);
  EB_Error_Code hookBeginCandidate (EB_Book* book, void* container, int argc, const unsigned int* argv);
  EB_Error_Code hookEndCandidateLeaf (EB_Book* book, void* container, int argc, const unsigned int* argv);
  EB_Error_Code hookEndCandidateGroup (EB_Book* book, void* container, int argc, const unsigned int* argv);
  EB_Error_Code hookNarrowJisx0208 (EB_Book* book, void* container, int argc, const unsigned int* argv);
  EB_Error_Code hookWideJisx0208 (EB_Book* book, void* container, int argc, const unsigned int* argv);
  EB_Error_Code hookGb2312 (EB_Book* book, void* container, int argc, const unsigned int* argv);
  EB_Error_Code hookIso8859_1 (EB_Book* book, void* container, int argc, const unsigned int* argv);
  EB_Error_Code hookNarrowFont (EB_Book* book, void* container, int argc, const unsigned int* argv);
  EB_Error_Code hookWideFont (EB_Book* book, void* container, int argc, const unsigned int* argv);
  EB_Error_Code hookBeginMonoGraphic (EB_Book* book, void* container, int argc, const unsigned int* argv);
  EB_Error_Code hookEndMonoGraphic (EB_Book* book, void* container, int argc, const unsigned int* argv);
  EB_Error_Code hookBeginGrayGraphic (EB_Book* book, void* container, int argc, const unsigned int* argv);
  EB_Error_Code hookEndGrayGraphic (EB_Book* book, void* container, int argc, const unsigned int* argv);
  EB_Error_Code hookBeginColorBmp (EB_Book* book, void* container, int argc, const unsigned int* argv);
  EB_Error_Code hookBeginColorJpeg (EB_Book* book, void* container, int argc, const unsigned int* argv);
  EB_Error_Code hookEndColorGraphic (EB_Book* book, void* container, int argc, const unsigned int* argv);
  EB_Error_Code hookBeginWave (EB_Book* book, void* container, int argc, const unsigned int* argv);
  EB_Error_Code hookEndWave (EB_Book* book, void* container, int argc, const unsigned int* argv);

 private:
  static const EB_Hook s_hooks[];
  EB_Hookset m_hookset;
  PageMaker *m_pageMaker;

  static EB_Error_Code hookFunc (EB_Book* book, EB_Appendix* appendix, void* ptr, EB_Hook_Code code, int argc, const unsigned int *argv);
};

__EBI_END_NAMESPACE

#endif /* __EBI_HOOKSET_H */

