/*
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2, or (at your option)
 * any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * Copyright (c) 2001  HASEGAWA Masafumi
 */

#ifndef __EBI_IMAGEPAGE_H
#define __EBI_IMAGEPAGE_H

#include "ebi_config.h"
#include "ebi_page.h"
#include "ebi_imagelink.h"
#include "ebi_bitmap.h"

__EBI_BEGIN_NAMESPACE

class ImagePage : public Page
{
 public:
  ImagePage (Subbook* subbook = NULL, const EB_Position* pos = NULL);
  virtual ~ImagePage ();

  virtual void clear ();
  virtual void draw (W low, W high);
  virtual W updateLayout ();
  virtual const Reference* getReference (const PNT& pnt) const;
  bool addBinary (const char* binary, int length);
  bool convertBinary (ImageLink::ImageType type);

 private:
  char* m_binary;
  int m_length;
  Bitmap m_bitmap;
};

__EBI_END_NAMESPACE

#endif /* __EBI_IMAGEPAGE_H */
