/*
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2, or (at your option)
 * any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * Copyright (c) 2001  HASEGAWA Masafumi
 */

#include "ebi_page.h"
#include "ebi_line.h"
#include "ebi_device.h"
#include "ebi_error.h"

__EBI_BEGIN_NAMESPACE

Page::Page (Subbook* subbook, const EB_Position* pos)
{
  m_subbook = subbook;
  m_pos.page = 0;
  m_pos.offset = 0;
  if (pos != NULL)
    {
      m_pos = *pos;
    }

  m_device = NULL;
}

Page::~Page ()
{
}

Subbook* Page::getSubbook () const
{
  return m_subbook;
}

void Page::setDevice (Device* device)
{
  m_device = device;
}

__EBI_END_NAMESPACE
