/*
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2, or (at your option)
 * any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * Copyright (c) 2001-2002  HASEGAWA Masafumi
 */

#ifndef __EBI_PAGESET_H
#define __EBI_PAGESET_H

#include "ebi_config.h"

__EBI_BEGIN_NAMESPACE

class Page;

class PageSet
{
 public:
  PageSet ();
  virtual ~PageSet ();

  Page* getCurrPage () const;
  Page* getPrevPage () const;
  Page* getNextPage () const;
  void insert (Page* page);
  void prevPage ();
  void nextPage ();

 private:
  enum
  {
    MAX_PAGE = 10,
  };

  typedef std::vector<Page*> Pages;

  Pages m_pages;
  int m_current;
};

__EBI_END_NAMESPACE

#endif /* __EBI_PAGESET_H */
