/*
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2, or (at your option)
 * any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * Copyright (c) 2001  HASEGAWA Masafumi
 */

#ifndef __EBI_TEXTPAGE_H
#define __EBI_TEXTPAGE_H

#include "ebi_config.h"
#include "ebi_page.h"

__EBI_BEGIN_NAMESPACE

class Line;

class TextPage : public Page
{
 public:
  TextPage (Subbook* subbook = NULL, const EB_Position* pos = NULL, bool bNoFold = false);
  virtual ~TextPage ();

  virtual void clear ();
  virtual void draw (W low, W high);
  virtual W updateLayout ();
  virtual const Reference* getReference (const PNT& pnt) const;
  void addLine (Line * line);
  void deleteLine (Line * line);

 private:
  Lines m_lines;
  bool m_bNoFold;
  bool m_bModified;
};

__EBI_END_NAMESPACE

#endif /* __EBI_TEXTPAGE_H */
