/*
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2, or (at your option)
 * any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * Copyright (c) 2001  HASEGAWA Masafumi
 */

#include "ebi_config.h"
#include "ebi_window.h"
#include "ebi_error.h"
#include "databox.h"

__EBI_BEGIN_NAMESPACE

Window::Windows Window::s_windows;
WFUNCREC Window::s_wfuncs;
WINFOREC* Window::s_winfos;

Window* Window::getWindow (W ix)
{
  if (ix >= 0 && ix < (W) s_windows.size ())
    {
      return s_windows[ix];
    }
  return NULL;
}

Window* Window::findWindow (W wid)
{
  for (int i = 0; s_winfos[i].wid != 0; ++i)
    {
      if (wid == s_winfos[i].wid)
	{
	  return s_windows[i];
	}
    }
  return NULL;
}

Window* Window::getActiveWindow ()
{
  W pid;
  W wid = wget_act (&pid);
  if (pid != 0)
    {
      return NULL;
    }

  return findWindow (wid);
}

W Window::bgfn ()
{
  // Хå饦ɽ  W   (*bgfn)(void);
  // ɥϼվ֤ǤʤΥХå饦ɽΤδؿǤꡢ
  // wf->bgfn NULL ξϡ ɥ٥Ȥ WAIT ⡼ɤǼФ롣
  // NULL Ǥʤϡɥ٥Ȥ NOWAIT ⡼ɤǼФ졢
  // EV_NOMSG 줿硢 δؿ¹Ԥ롣
  // ؿ  0 ξϡevt_loop() ꥿󤷡evt_loop() δؿͤϡ
  // bgfn() δؿͤȤʤ롣

  return 0;
}

void Window::idlefn ()
{
  // IDLE      VOID (*idlefn)(void);
  // EV_NULL 줿˼¹Ԥ롣
  // ̾ϡݥ󥿷ѹ ( ɥ˥ݥ󥿤 ) 
  // å / ΰΥĥԤ
  // wf->idlefn  NULL ξϲ⤷ʤ

  UW time = wevt.s.time; // ȯ
  PNT pos = wevt.s.pos; // PDкɸ
  H cmd = wevt.s.cmd; // ֥
  H wid = wevt.s.wid; // WID
  UW stat = wevt.s.stat; // 

  for (Windows::iterator wi = s_windows.begin (); wi != s_windows.end (); ++wi)
    {
      (*wi)->onIdle (time, pos, cmd, wid, stat);
    }
}

W Window::msgfn (MESSAGE* msg)
{
  // ̥å    W   (*msgfn)(MESSAGE *msg);
  // EV_MSG 줿˼¹Ԥ롣 msg ϡ 줿̥å
  // Ƭ 4 ХȤǼƤΰؤΥݥ󥿤Ǥ롣
  // δؿǤϡrsv_msg() ˤåФб
  // ԤʤȤˤʤ롣
  // ؿ͡ 0 ξϡevt_loop() ꥿󤷡 evt_loop() δؿͤϡ
  // msgfn() δؿͤȤʤ롣
  // wf->msgfn  NULL ξ줿åФƼΤƤ롣

  // ƬΥå򥯥ꥢ (ɤФ)
  clr_msg (MM_ALL, MM_ALL);

  return E_OK;
}

W Window::menufn ()
{
  // ˥塼      W   (*menufn)(void);
  // EV_MENU 줿˼¹Ԥ롣 ¹Իˤϥݥ󥿷ϡءפ
  // ѹƤ뤿ᡢ ؿǤϥݥ󥿷ꤹɬפϤʤ
  // ؿ͡0 ξϡevt_loop() ꥿󤷡 evt_loop() δؿͤϡ
  // menufn() δؿͤȤʤ롣
  // wf->menufn = NULL ξϲ⤷ʤ

  UW time = wevt.s.time; // ȯ
  PNT pos = wevt.s.pos; // PDкɸ
  H cmd = wevt.s.cmd; // ֥
  H wid = wevt.s.wid; // WID
  UW stat = wevt.s.stat; // 

  Window* window = getActiveWindow ();
  if (window != NULL)
    {
      return window->onMenu (time, pos, cmd, wid, stat);
    }
  return 0;
}

void Window::dspfn (W ix, W mode, RECT * rect)
{
  // ɽ      VOID (*dspfn)(W ix, W mode, RECT *new);
  // ɥɽѤδؿǤꡢix оݥɥΥɥ
  // 쥳Υǥå (0) 򼨤mode ϡʲκɽװ򼨤
  // ɽ  new   
  // mode = -1 : ɽ׵                  NULL       
  //      =  0 : ɽ׵ᥤ٥            NULL       
  //      =  1 : ɥåư                  NULL       
  //      =  2 : ɥåѷ                  ΰ 
  //      =  3 : ɥåѷ                  ΰ 
  //      =  4 : ̾⡼ڴ                ΰ 
  //      =  5 : ̥⡼ڴ                ΰ 
  //      =  6 : ̾⡼ڴ                ΰ 
  //      =  7 : ѥͥ                    NULL       
  //      =  8 : ѹ                      ΰ 
  //      =  9 : ѹ                      ΰ 
  // ɽ׵ϡevt_loop() ¹Ԥˡ ǽΰܤɥ
  // 쥳ϿƤ륦ɥФȯ롣
  // ѥͥϡѥͥ뤬줿ˡ ѥͥ˱Ƥɥ
  // ФƸƤӽФΤǡ ѥͥɽ˥ɥƤѹ
  // ɽԤʤɬפ롣 ɥƤѹƤʤϡ 
  // ɽԤʤɬפϤʤ ׵ϡWA_BGDSP °ĥɥǤġ
  // bgfnNULL ξΤȯ롣
  // ѹϡɥ֤ѹ줿ȯ롣
  // ɽɬפʾϡwsta_dsp()wend_dsp() ˤꡢ ɽɬפΰ
  // Фơ®䤫˺ɽԤʤɬפ롣
  // wf->dspfn = NULL ǤäƤϤʤ

  Window* window = getWindow (ix);
  if (window != NULL)
    {
      window->onDisplay (mode, rect);
    }
}

void Window::stsfn (W ix, W sts)
{
  // Ѳ      VOID (*stsfn)(W ix, W sts);
  // ɥξѹФƼ¹ԤؿǤꡢ ix оݥɥ
  // ɥ쥳Υǥå ( 0  ) 򼨤 sts ϡ
  // ʲξѹװ򼨤
  // sts = 0     : EV_INACT ȯ ( ¾ɥؤڤ괹)       
  //     = 1     : EV_SWITCH ޤ EV_RSWITCH ȯ                
  //     = 2     : W_SWITCH ȯ (¾ɥ)          
  //     = 0x100 : EV_INACT ȯ (ѥͥؤڤ괹)              
  //     = 0x102 : W_SWITCH ȯ (ѥͥ뤫)                
  //     < 0     : W_CLOSED ȯ ( wid  -sts Ȥʤ) 
  // EV_RSWITCH ȯϡ ޤ dspfn() ¹Ԥ졢θ塢stsfn() 
  // sts = 1 Ǽ¹Ԥ졢 Ǹ PD Υץ쥹֤˱ presfn() ¹Ԥ롣
  // EV_SWITCH ȯϡ stsfn()  sts = 1 Ǽ¹Ԥ졢  PD 
  // ץ쥹֤˱ presfn() ¹Ԥ롣
  // sts = 2(W_SWITCH) ξϡ stsfn() μ¹ԸˡPDΥץ쥹б
  // ¹ԤΤǡ stsfn() ǤϾѹνΤߤԤʤȤˤʤ롣
  // sts0x100 (EV_INACT)0x102(W_SWITCH) ϡ줾ѥͥ뤬ץ󤵤줿硢
  // ӡ줿ȯ롣 ѥͥξϡɽ᡼
  // ¸ / 뤿ᡢ §ȤɽѹԤäƤϤʤ
  // sts = 0,1,2  sts < 0 ΤȤϡ ɥΥѡĤϤ٤ P_ACT֡
  //  P_NODISP ֤ꤵ뤿ᡢ ѡĤκɽԤɬפ롣
  // ޤsts = 0 λϡ ɥΥѡĤϤ٤ P_INACT ֡  
  // P_NODISP ֤ꤵ뤿ᡢ ѡĤκɽԤɬפ롣
  // wf->stsfn = NULL ǤäƤϤʤ

  Window* window = getWindow (ix);
  if (window != NULL)
    {
      window->onStatus (sts);
    }
}

W Window::keyfn ()
{
  // Ͻ      W   (*keyfn)(void);
  // EV_KEY, EV_AUTKEY ȯ˼¹ԤؿǤ롣
  // ؿ  0 ξϡevt_loop() ꥿󤷡 evt_loop() δؿͤϡ
  // keyfn() δؿͤȤʤ롣
  // wf->keyfn = NULL ξϲ⤷ʤ

  UW time = wevt.s.time; // ȯ
  PNT pos = wevt.s.pos; // PDкɸ
  H key = wevt.s.cmd; // 
  H ch = wevt.s.wid; // ʸ
  UW stat = wevt.s.stat; // 

  Window* window = getActiveWindow ();
  if (window != NULL)
    {
      return window->onKey (time, pos, key, ch, stat);
    }
  return 0;
}

W Window::presfn (W ix)
{
  // PDץ쥹      W   (*presfn)(W ix);
  // ɥκΰǤ PD ץ쥹ФƼ¹ԤؿǤꡢ
  // ix оݥɥΥɥ쥳Υǥå ( 0  ) 򼨤
  // ؿ͡ 0 ξϡ evt_loop() ꥿󤷡 evt_loop() δؿͤϡ
  // presfn() δؿͤȤʤ롣
  // wf->presfn = NULL ξϲ⤷ʤ

  UW time = wevt.s.time; // ȯ
  PNT pos = wevt.s.pos; // PDкɸ
  H cmd = wevt.s.cmd; // ֥
  UW stat = wevt.s.stat; // 

  Window* window = getWindow (ix);
  if (window != NULL)
    {
      return window->onPress (time, pos, cmd, stat);
    }
  return 0;
}

W Window::finfn (W ix, W mode)
{
  // λ      W   (*finfn)(W ix, W mode);
  // ɥνλ׵ФƼ¹ԤؿǤꡢ ix оݥɥ
  // ɥ쥳Υǥå ( 0  ) 򼨤mode ϡ
  // ʲνλ׵װ򼨤
  // mode = 0 : ԥȥΥ֥륯åˤ뽪λ׵ 
  //      = 1 : W_DELETE ׵ᥤ٥Ȥˤ뽪λ׵        
  //      = 2 : W_FINISH ׵ᥤ٥Ȥˤ뽪λ׵        
  // mode = 0 ξ硢 ؿ͡ 0 λϡevt_loop() ꥿󤷡 
  // δؿͤ finfn() δؿͤȤʤ롣
  // mode=1 (W_DELETE ׵) ξ硢 ץꥱԽƤѹ
  // С ѥͥɽˡƤ¸塢 ɥĤ
  // Ǥ¤®˽λʤƤϤʤ
  // mode=2 (W_FINISH ׵)ξ硢 ץꥱԽƤѴ
  // ¨¤˥ɥĤƽλʤƤϤʤ
  // mode = 1, 2ǡ λ׵ϡؿ͡0 ᤹Ȥˤꡢ 
  // ׵ȯץ W_ACK 쥹ݥ󥹤ᤵ졢 evt_loop() ꥿󤷡
  // δؿͤ finfn() δؿͤȤʤ롣 λ׵ʤϡ 
  // ؿ = 0᤹Ȥˤꡢ ׵ȯץ W_NAK 쥹ݥ󥹤ᤵ졢
  // evt_loop() ³Ԥ롣 
  // λ׵α¨¤᤹ɬפ뤿ᡢfinfn() Ǥϡ
  // βݤΤߤȽǤ ºݤΥɥΥ finfn() 
  // λ˹Ԥɬפ롣
  // wf->finfn = NULL ǤäƤϤʤ

  Window* window = getWindow (ix);
  if (window != NULL)
    {
      return window->onFinish (mode);
    }
  return 0;
}

W Window::pastefn (W ix, PNT pos)
{
  // Ž߽      W   (*pastefn)(W ix, PNT pos);
  // ɥؤΥɥåˤŽ׵ ( W_PASTE ׵ᥤ٥ ) Ф
  // ¹ԤؿǤꡢ ix оݥɥΥɥ쥳
  // ǥå ( 0  ) 򼨤pos Ž߰ ( кɸ ) 򼨤
  // pos ̾Žޤǡΰκΰ֤򼨤ΤȤ롣 
  // ä W_PASTE ׵ᥤ٥Ȥ¦Υץꥱϡ pos Ȥ
  // Žǡΰκκɸͤ ŽΥɥкɸͤ
  // ꤹɬפ롣
  // ˡ׵ᥤ٥Ȥ¦Υץꥱϡ Ž
  // ݥ󥿤κɸͤ ŽΥɥкɸͤǡ wevt.s.time 
  // ( pt.x << 16 | pt.y ) ηꤷƤɬפ롣
  // ŽߤνǤϡpos ǻꤵǡΰκΰ֡ ⤷
  // wevet.s.time Ǽݥ󥿤ΰ֤Τ줫Ѥ뤳Ȥˤʤ롣
  // ؿ = W_ACK ξ ACK 쥹ݥ󥹤ᤵ졢 ؿ  W_ACK ξ 
  // NAK 쥹ݥ󥹤ᤵ롣
  // ץꥱˤäƤϡ ٤ƤŽߤʣȤƼ갷
  // ꡢ Τ褦ʾϡW_ACK δؿ᤹ͤˡ 
  // wevt.s.pos.x = wevt.s.pos.y = 0x8000 ꤷƤ Ž¦
  // ץꥱ W_ACK α줿Ȥ 
  // wevt.s.pos.x == wevt.s.pos.y == 0x8000 ξϡ ưǤϤʤ
  // ʣ̤ȤƼ갷ʤƤϤʤ
  // Žߤȼɽ˻֤ϡ Ž߸ǤΥॢȤ
  // ʤǽ뤿ᡢ Ǥ᤯pastefn() λ ӡ
  // ɽԤɬפ롣
  // wf->pastefn = NULL ξϲ⤻ˡNAK 쥹ݥ󥹤ᤵ롣

  Window* window = getWindow (ix);
  if (window != NULL)
    {
      return window->onPaste (pos);
    }
  return 0;
}

W Window::respfn (W ix, W cmd)
{
  //           W   (*respfn)(W ix, W cmd);
  // 餫α٥Ȥ˼¹ԤؿǤꡢ ix о
  // ɥΥɥ쥳Υǥå ( 0  ) 򼨤
  // cmd ϼ٥Ȥ cmd 򼨤 cmd ˤ W_ACK ޤ W_NAK 
  // ɬåȤƤ롣 ؿ͡0 ξϡevt_loop() ꥿󤷡 
  // evt_loop() δؿͤϡrespfn() δؿͤȤʤ롣
  // wf->respfn = NULL ξϲ⤷ʤ

  Window* window = getWindow (ix);
  if (window != NULL)
    {
      return window->onResponse (cmd);
    }
  return 0;
}

void Window::scrlfn (W ix, W type, W diff)
{
  //         VOID (*scrlfn)(W ix, W type, W diff);
  // ɥΥ׵ФƼ¹ԤؿǤꡢ ix 
  // оݥɥΥɥ쥳Υǥå ( 0  ) 򼨤
  // type ϥμ򼨤ʲͤǤ롣
  // XXXX XXXX XXCC TTDD
  // CC = 0 : С 1 : С 2 : С
  // TT = 0 : ࡼ 1 : ꥢ 2 : ץ
  // DD = 0 : 她 1 :  2 :  3 : 
  // X      : ̤(0)
  // diff ϥץξ硢 
  // ( ץ clo  ) - ( ץ clo ) Ȥʤ롣
  // ࡼξ硢 ͤϢ³ࡼΥ
  // ؿθƤӽФ ( ǽ 0) 򼨤ͤȤʤ롣
  // ڡξ硢ͤϰ̣ʤ
  // ץꥱб륹Ԥʤä塢 Сɽ
  // Ԥʤɬפ롣
  // ɥ˥С¸ߤϡ wf->scrlfn = NULL ǤäƤ
  // ʤ С¸ߤʤϡwf->scrlfn  NULL Ǥ褤
  // ʤ桼Ķˤäƥưɽɽ褦
  // Ƥϡ б륹СФcchg_par( PID, P_DRAGBREAK)
  // ˤäơ ɽؤбץꥱ¦Ƥ
  // ˸¤ꡢ ɽԤȤǤ롣

  Window* window = getWindow (ix);
  if (window != NULL)
    {
      window->onScroll (type, diff);
    }
}

void Window::devfn (TC* devname)
{
  // ǥХ٥Ƚ    VOID (*devfn)(TC *devname);
  // EV_DEVICE ȯˡ ¿ / ȥޥ͡ oprc_dev() ؿ
  // ¹Ԥˡ ¹ԤؿǤꡢdevname ˤϡEV_DEVICE оݤ
  // ʤǥХ̾ؤΥݥ󥿤Ϥ롣
  // ǥˤ EV_DEVICE ξϡ ¿/ȥޥ͡νˤꡢ
  // Ǥ˥ǥ³Ƥꡢ ³̾ǥХ̾ƱǤ롣
  // ƥǥ³̾ "SYS"Ȥʤ롣
  // ¿/ȥޥ͡ oprc_dev() üʴؿ¹Ԥϡ
  // evt_loop() ¹Ԥˡ ؿݥ p_oprc_dev  oprc_dev() ȸߴ
  // üʴؿꤷƤȤˤꡢ ꤷüʴؿ oprc_dev() 
  // ˼¹Ԥ뤳ȤǤ롣
  // wf->devfn = NULL ξϲ⤷ʤ ( ¿ / ȥޥ͡νϼ¹Ԥ )

  onDevice (devname);
}

void Window::vobjfn (W ix)
{
  // ׵ᥤ٥Ƚ  VOID (*vobjfn)(W ix);
  // ׵ᥤ٥ ( W_VOBJREQ ) ȯ˼¹ԤؿǤꡢ
  // ix оݥɥΥɥ쥳Υǥå ( 0  ) 򼨤
  // ׵ᥤ٥Ȥϡ ¿ȡȥޥ͡㤫ȯԤ cmd = W_VOBJREQ 
  // ׵ᥤ٥ȤǤꡢ wevt.g.data[2] ˤꡢ ׵Υפ롣
  // ξ٥Ȥᤵʤ
  // wevt.g.data[2] = 0        ̾ѹ줿                                             
  //                  1        ֤ˤʤä                                           
  //                  2        ֤줿                                       
  //                  3        Ⱦ֤ˤʤä                                           
  //                  4        Ⱦ֤줿                                       
  //                  5        ȥɥˤʤä                                     
  //                  6        ȥɥ줿                                 
  //                  714    (ͽ)                                                     
  //                  15       Ȥѹ                                             
  //                  16       Ȥ׵(ե륷ƥ³)                       
  //                  17       Ȥ׵(¿Ȥؤ¸)                           
  //                  18     (ͽ)                                                     
  //                  128      ԽƤΰեؤγǼ׵                         
  // wevt.g.data[3] = оݲID (vid)
  //                  ȥɥξϡɥβID (vid) 
  // wf->vobjfn = NULL ξϡ ׵᥿ < 128 ξϲ⤻ 
  // ׵᥿  128 ξϡER_NOSPT 顼 orsp_prc() ˤ᤹ 
  // Ȥޤ०ɥξϡNULL ǤäƤϤʤ

  W type = wevt.g.data[2];
  W vid = wevt.g.data[3];

  Window* window = getWindow (ix);
  if (window != NULL)
    {
      window->onVobj (type, vid);
    }
}

W Window::eventLoop ()
{
  s_wfuncs.bgfn = bgfn;
  s_wfuncs.idlefn = idlefn;
  s_wfuncs.msgfn = msgfn;
  s_wfuncs.menufn = menufn;
  s_wfuncs.dspfn = dspfn;
  s_wfuncs.stsfn = stsfn;
  s_wfuncs.keyfn = keyfn;
  s_wfuncs.presfn = presfn;
  s_wfuncs.finfn = finfn;
  s_wfuncs.pastefn = pastefn;
  s_wfuncs.respfn = respfn;
  s_wfuncs.scrlfn = scrlfn;
  s_wfuncs.devfn = devfn;
  s_wfuncs.vobjfn = vobjfn;

  int size = s_windows.size ();
  s_winfos = new WINFOREC[size + 1];
  memset (s_winfos, 0, sizeof (WINFOREC) * (size + 1));
  for (int i = 0; i < size; ++i)
    {
      s_windows[i]->getWinfo (s_winfos + i);
    }

  W exitCode = evt_loop (&s_wfuncs, s_winfos);

  delete []s_winfos;

  return exitCode;
}

Window::Window ()
{
  s_windows.push_back (this);
}

Window::~Window ()
{
  Windows::iterator wi = std::find (s_windows.begin (), s_windows.end (), this);
  s_windows.erase (wi);
}

void Window::onIdle (UW time, PNT pos, H cmd, H wid, UW stat)
{
}

W Window::onMenu (UW time, PNT pos, H cmd, H wid, UW stat)
{
  return 0;
}

void Window::onDisplay (W mode, const RECT* rect)
{
}

void Window::onStatus (W sts)
{
}

W Window::onKey (UW time, PNT pos, H key, H ch, UW stat)
{
  return 0;
}

W Window::onPress (UW time, PNT pos, H cmd, UW stat)
{
  return 0;
}  

W Window::onFinish (W mode)
{
  return 1;
}

W Window::onPaste (PNT pos)
{
  return W_NAK;
}  

W Window::onResponse (W cmd)
{
  return 0;
}  

void Window::onScroll (W type, W diff)
{
}  

void Window::onDevice (const TC* devname)
{
}

void Window::onVobj (W type, W vid)
{
}  

__EBI_END_NAMESPACE
